package it.bz.prov.mercurius.logic;

import it.bz.prov.mercurius.entity.Fornitura;
import it.bz.prov.mercurius.entity.FornituraPk;
import it.bz.prov.mercurius.entity.Particella;
import it.bz.prov.mercurius.ibusiness.IBusRemote;
import it.bz.prov.mercurius.util.Constants;
import it.bz.prov.mercurius.util.Helper;
import it.bz.prov.mercurius.util.WSUtil;
import it.sian.cooperazione.schema.fornitura.InputInvioFornitura;
import it.sian.cooperazione.schema.fornitura.InputInvioFornituraParticellaVariataDatiGISLimiteParticellaShape;
import it.sian.cooperazione.wspdd.services.InterService;

import java.io.IOException;
import java.rmi.RemoteException;

import javax.annotation.PostConstruct;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.apache.log4j.Logger;

@Stateless
public class SenderBean implements IBusRemote {

	Logger log = Logger.getLogger(this.getClass());

	@PersistenceContext(unitName = "SPADEV")
	private EntityManager emanGis;

	 @PersistenceContext(unitName = "MERCURIUS")
	 private EntityManager emanMerc;

	@PostConstruct
	private void init() {
		try {
			Helper.loadProperties();

		} catch (IOException ioe) {
			System.err.println(ioe.getMessage());
		}

		return;
	}

	@Override
	public void send(String id) {
		final String methodName = "send";
		log.info(methodName);
		// TODO: Read by codiceComune, max 200 minus those already send (check
		// by id)
		Particella p = emanGis.find(Particella.class, new Integer(id));
		if (p != null) {
			System.out.println("Found Particella variata with id " + id);
			System.out.println("This particella has " + p.getSuoli().size() + " suoli element(s)");
			System.out.println(p.getParticella());
			
			InputInvioFornitura forn = Helper.getInputInvioFornitura(p);
			if (forn != null ){
				System.out.println("did it");
			}
			
			
//			write();

			WSUtil wsu = new WSUtil();
			InterService is = wsu.getAllineamentoGisService(Constants.FORNITURA_PARTICELLE);
			try {
				is.fornituraParticelleVariate(null);

			} catch (RemoteException e) {
				// TODO Auto-generated catch block
				log.error(methodName, e);
			}

		}

		return;

	}

	@Override
	public void checkStatus() {
		// TODO Auto-generated method stub
		return;

	}

	 private void write() {
	 FornituraPk pk = new FornituraPk(new Integer(3), new Integer(2));
	
	 Fornitura agea = new Fornitura();
	 agea.setpKey(pk);
	 agea.setCodComune("B220");
	 agea.setFoglio(Constants.FOGLIO);
	 agea.setLastUpdate(Helper.convert("31/08/2011"));
	 agea.setMotivo("Questo e' un test!");
	 agea.setParticella("5678");
	 agea.setSubalterno("09");
	 agea.setTavola("123");
	 agea.setTipoFornitura("PI");
	 emanMerc.persist(agea);
	 return;
	
	 }

}
